/*
 * Copyright (C) 2019 CERN (www.cern.ch)
 * Author: Jean-Claude BAU - CERN
 *
 * Released according to the GNU LGPL, version 2.1 or any later version.
 *
 */

#ifndef HAL_TIMER_H
#define HAL_TIMER_H

#include <libwr/timeout.h>

// List of all timer
typedef enum {
	// RESERVED
	TMO_END_BLOCK,
	// MAIN
	TMO_UPDATE_ALL=1,
	TMO_UPDATE_FAN,
	// PORTS
	TMO_PORT_TMO_RTS,
	TMO_PORT_POLL_SFP,
	TMO_PORT_SFP_DOM,
	TMO_UPDATE_SYNC_LEDs,
	TMO_UPDATE_LINK_LEDS,

}tmo_id_t;

typedef struct {
	tmo_id_t id;
	uint32_t tmoMs; // Time out value in ms
	uint32_t tmoMsRef; // Time out reference value in ms
	int repeat; // restart timeout automatically
	timeout_t timer;
	void (*cb)(int timerId);
}timer_parameter_t;

extern void timer_update_tmo(tmo_id_t id,uint32_t tmoMs);
extern void timer_restore_tmo(tmo_id_t id);
extern void timer_init(timer_parameter_t *p);
extern void timer_scan(timer_parameter_t *p);

#endif
